#version 150

#moj_import <fog.glsl>

#moj_import <map_data.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;
in vec4 normal;

in vec3 chunkPosition;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0);
    float fogStart = FogStart;
    float fogEnd = FogEnd;

    if (color.a >= 0.8 && color.a < 0.9) {
        if (chunkPosition.y < 0.0) {
            color.a = 1.0;
            color *= vertexColor * ColorModulator;

            fogStart -= REPEAT_LENGTH;
			fogEnd -= REPEAT_LENGTH;
        }
        else {
            discard;
        }
    }
    else if (color.a >= 0.7 && color.a < 0.8) {
        color.a = 0.0;
        color *= vertexColor * ColorModulator;
    }
    else if (color.a >= 0.6 && color.a < 0.7 ) {
        color.a = 1.0;
    }
    else if (color.a >= 0.5 && color.a < 0.6) {
        color.a = 0.0;
    }
    else if (color.a >= 0.3 && color.a < 0.4) {
        color.a = 0.0;
    }
    else {
        color *= vertexColor * ColorModulator;
    }

    if (color.a < 0.1) {
        discard;
    }

    fragColor = linear_fog(color, vertexDistance, fogStart, fogEnd, FogColor);
}
